<?php
/*
* Copyright (c) 2004-2006, woah-projekt.de
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* * Redistributions of source code must retain the above copyright
*   notice, this list of conditions and the following disclaimer.
* * Redistributions in binary form must reproduce the above copyright
*   notice, this list of conditions and the following disclaimer
*   in the documentation and/or other materials provided with the
*   distribution.
* * Neither the name of the phgstats project (woah-projekt.de)
*   nor the names of its contributors may be used to endorse or
*   promote products derived from this software without specific
*   prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
* FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
* COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
* LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
* ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
* POSSIBILITY OF SUCH DAMAGE.
*/
if (!defined('PHGDIR')) { exit(); }

if (file_exists('install/index.php')) { die('install/index.php must be deleted!<br>Not installed yet? Click <a href="install/index.php">here</a>!'); }

include_once(PHGDIR . 'settings/config_navi.inc.php');     // phgstats configuration
include_once(PHGDIR . 'classes/phgstats_n.class.php');  // main phgstats class
$gameservernavi_old = $gameservernavi;

for ($i = (count($gameservernavi_old) - 1), $k = 0; $i >= 0; $i--, $k++)
{
        $gameservernavi[$k] = $gameservernavi_old[$i];
}

$phgdir = PHGDIR;

// get data of server
function infonavi($phgdir, $sh_srv, $game, $host, $port, $queryport)
{
    // create server the object
    $phgstatsnavi = phgstatsnavi::query($game[$sh_srv]);

    // get the serverinfo string
    $server = $phgstatsnavi->getstream($host[$sh_srv], $port[$sh_srv], $queryport[$sh_srv]);

    if ($server === true)
    {
        // get the server rules
        $srv_rules  = $phgstatsnavi->getrules($phgdir);
        $srv_rules['playerlist'] = $phgstatsnavi->getplayers();

        // full path to the map picture
        $srv_rules['map'] = $phgdir . $srv_rules['map_path'] . '/' . $srv_rules['mapname'] . '.jpg';

        if (!(file_exists($srv_rules['map'])))
        { // set default map if no picture found
            $srv_rules['map'] = $phgdir . $srv_rules['map_path'] . '/' . $srv_rules['map_default'];
        }
    }
    else
    {
        // default values if no response
        $msg = 'No Response';

        $srv_rules['hostname']    = $msg;
        $srv_rules['gamename']    = $msg . "<br>";
        $srv_rules['map']         = $phgdir . 'maps/no_response.jpg';
        $srv_rules['sets']        = '-';
        $srv_rules['htmlinfo']    = '<tr valign="top"><td align="left">No</td><td align="left">Response</td></tr>' . "\n";
        $srv_rules['htmldetail'] = '<tr valign="top"><td align="left">No</td><td align="left">Response</td></tr>' . "\n";
    }

    // get server adress
    $srv_rules['adress'] = $host[$sh_srv] . ':' . $port[$sh_srv];

    return $srv_rules;
}

// show the data of two or more server
function srv_listnavi ($sh_srv, $srv_rules, $use_file)
{
         // html: map picture
        echo '<tr valign="top">' . "\n"
        . '<td class="box" align="center">'
        . '<a href="hlsw://' . $srv_rules['adress'] . '" title="add HLSW">'
        . '<img height="100" width="120" src="'
        . $srv_rules['map'] . '" border="0" alt="'
        . $srv_rules['mapname'] . '"></a><br>' . "\n";

        // html: server ip and gamename
        echo $srv_rules['adress']
        . '<br>'
        . $srv_rules['hostname']
        . '<br>'
        . $srv_rules['gamename'] . "\n";

         // html: server details table
         echo '<table border="0" cellpadding="3" cellspacing="0">' . "\n"
         . $srv_rules['htmlinfo'] // now the info generate from game class by balgo on 05.01.2006
         . '</table>' . "\n"
         . '<hr>'. "\n";

        echo '</td></tr>' . "\n";


}

echo '<center>' . "\n";


// how much server must scan
$index = count($gameservernavi);

while($index)
{
  $index--;

  list($game[$index], $host[$index], $port[$index], $queryport[$index]) = split(':', $gameservernavi[$index]);
}


{
    $sh_srv = count($host);

        // html: open table to show more server
        echo '<table border="0" cellpadding="2" cellspacing="2" width="' . $phgtablebox . '">' . "\n";

        // html: gameserver list data
        while ($sh_srv)
        {
            $sh_srv--;
            $srv_rules = infonavi($phgdir, $sh_srv, $game, $host, $port, $queryport);
            srv_listnavi($sh_srv, $srv_rules, $use_file);
            flush();
        }

        // html: close table with server info
        echo '</table>' . "\n";

}

// html: our copyright, dont remove !
echo '<table cellpadding="0" cellspacing="0" border="0">'. "\n"
   . '<tr><td class="auth" align="center">'
   . '<a href="http://phgstats.sourceforge.net/" target="_blank">phgstats 0.6.2</a> &copy; 2004-2006 <a href="'
   . 'http://woah-projekt.de/" target="_blank">woah-projekt</a>'
   . '</td></tr>' . "\n"
   . '</table></center>';
?>